"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const javaUtil_1 = require("./java/javaUtil");
class CodegenModelFactory {
}
CodegenModelFactory.typeMapping = javaUtil_1.newHashMap();
/**
 * Configure a different implementation class.
 *
 * @param type           the type that shall be replaced
 * @param implementation the implementation class must extend the default class and must provide a public no-arg constructor
 */
CodegenModelFactory.setTypeMapping = function (type, implementation) {
    if (!(implementation.prototype instanceof type.getDefaultImplementation())) {
        throw new Error(implementation + " doesn't extend " + type);
    }
    CodegenModelFactory.typeMapping.put(type, implementation);
};
CodegenModelFactory.newInstance = function (type) {
    const classType = CodegenModelFactory.typeMapping.get(type) ||
        type.getDefaultImplementation();
    return new classType();
};
exports.default = CodegenModelFactory;
//# sourceMappingURL=CodegenModelFactory.js.map