"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const ConfigHelp_1 = __importDefault(require("./cmd/ConfigHelp"));
const Generate_1 = __importDefault(require("./cmd/Generate"));
const Langs_1 = __importDefault(require("./cmd/Langs"));
const Meta_1 = __importDefault(require("./cmd/Meta"));
const cli_1 = require("./java/cli");
/**
 * User: lanwen
 * Date: 24.03.15
 * Time: 17:56
 * <p>
 * Command line interface for swagger codegen
 * use `swagger-codegen-cli.jar help` for more info
 *
 * @since 2.1.3-M1
 */
class SwaggerCodegen {
    static main(args) {
        return __awaiter(this, void 0, void 0, function* () {
            return cli_1.Cli.builder('swagger-codegen-cli')
                .withDescription('Swagger code generator CLI. More info on swagger.io')
                .withDefaultCommand(Langs_1.default)
                .withCommands(Generate_1.default, Meta_1.default, Langs_1.default, cli_1.Help, ConfigHelp_1.default)
                .build()
                .parse(args);
        });
    }
}
exports.default = SwaggerCodegen;
if (require.main === module) {
    SwaggerCodegen.main(process.argv.slice(2)).then(console.log, err => {
        console.error(err.message);
        process.exit(1);
    });
}
//# sourceMappingURL=SwaggerCodegen.js.map