"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const CodegenConfigLoader_1 = __importDefault(require("../CodegenConfigLoader"));
const cli_1 = require("../java/cli");
class ConfigHelp {
    constructor({ language }) {
        this.language = language;
    }
    run() {
        let config = CodegenConfigLoader_1.default.forName(this.language);
        console.info('CONFIG OPTIONS');
        for (const langCliOption of config.cliOptions()) {
            {
                console.info('\t' + langCliOption.getOpt());
                console.info('\t    ' +
                    langCliOption
                        .getOptionHelp()
                        .replace(new RegExp('\n', 'g'), '\n\t    '));
                console.info();
            }
        }
    }
}
ConfigHelp.Usage = new cli_1.Command({ name: 'config-help', description: 'Config help for chosen lang' }, [
    {
        name: ['-l', '--lang'],
        title: 'language',
        required: true,
        hasArg: true,
        description: 'language to get config help for',
    },
]);
exports.default = ConfigHelp;
//# sourceMappingURL=ConfigHelp.js.map