"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const AbstractModel_1 = __importDefault(require("./AbstractModel"));
const factory_1 = __importDefault(require("./factory"));
const javaUtil_1 = require("../java/javaUtil");
const beanUtils_1 = require("../java/beanUtils");
class ArrayModel extends AbstractModel_1.default {
    constructor() {
        super(...arguments);
        this.type = 'array';
    }
    description(description) {
        this.setDescription(description);
        return this;
    }
    items(items) {
        this.setItems(items);
        return this;
    }
    minItems(minItems) {
        this.setMinItems(minItems);
        return this;
    }
    maxItems(maxItems) {
        this.setMaxItems(maxItems);
        return this;
    }
    getType() {
        return this.type;
    }
    setType(type) {
        this.type = type;
    }
    getDescription() {
        return this.__description;
    }
    setDescription(description) {
        this.__description = description;
    }
    getItems() {
        return this.__items;
    }
    setItems(items) {
        this.__items = factory_1.default(items);
    }
    getProperties() {
        return this.properties;
    }
    setProperties(properties) {
        this.properties = javaUtil_1.asMap(properties);
    }
    getExample() {
        return this.example;
    }
    setExample(example) {
        this.example = example;
    }
    getMinItems() {
        return this.__minItems;
    }
    setMinItems(minItems) {
        this.__minItems = minItems;
    }
    getMaxItems() {
        return this.__maxItems;
    }
    setMaxItems(maxItems) {
        this.__maxItems = maxItems;
    }
    clone() {
        return beanUtils_1.apply(new this.constructor(), this);
    }
}
exports.default = ArrayModel;
//# sourceMappingURL=ArrayModel.js.map