"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const AbstractModel_1 = __importDefault(require("./AbstractModel"));
const javaUtil_1 = require("../java/javaUtil");
class ComposedModel extends AbstractModel_1.default {
    constructor() {
        super(...arguments);
        this.allOf = [];
    }
    parent(model) {
        this.setParent(model);
        return this;
    }
    child(model) {
        this.setChild(model);
        return this;
    }
    interfaces(interfaces) {
        this.setInterfaces(interfaces);
        return this;
    }
    getDescription() {
        return this.description;
    }
    setDescription(description) {
        this.description = description;
    }
    getProperties() {
        return null;
    }
    setProperties(properties) { }
    getExample() {
        return this.example;
    }
    setExample(example) {
        this.example = example;
    }
    getAllOf() {
        return this.allOf;
    }
    setAllOf(allOf) {
        this.allOf = allOf;
    }
    getParent() {
        return this.__parent;
    }
    setParent(model) {
        this.__parent = model;
        if (this.allOf.indexOf(model) === -1) {
            this.allOf.push(model);
        }
    }
    getChild() {
        return this.__child;
    }
    setChild(model) {
        this.__child = model;
        if (this.allOf.indexOf(model) === -1) {
            this.allOf.push(model);
        }
    }
    getInterfaces() {
        return this.__interfaces;
    }
    setInterfaces(interfaces) {
        this.__interfaces = interfaces;
        for (const model of interfaces) {
            if (this.allOf.indexOf(model) === -1) {
                this.allOf.push(model);
            }
        }
    }
    clone() {
        return javaUtil_1.apply(new this.constructor(), this);
    }
}
exports.default = ComposedModel;
//# sourceMappingURL=ComposedModel.js.map